#ifndef _QMEDIAN_INC
#define _QMEDIAN_INC

typedef struct quantstruc {
  void * first;
  void * last;
  void * zeromap;
  void * zerolast;
  void * colmap;
  void * lastcolmap;
  int colors;
  int zeros;
} QUANT;

/* Use newquant to allocate a new quantize base. */
extern QUANT * newquant(void);

/* Add colormaps with qaddcolormap & qaddcolormap64.
 * If you mix 256-base and 64-base maps, remember to use
 * qaddcolormap64; otherwise, use qaddcolormap and the result
 * will be the same base as the input.
 * These functions return the index to the idxmap where this
 * currently added colormap will start.
 * These calls do not free colmaps.
 */
extern int qaddcolormap(QUANT * q, char * colmap, int colors);
extern int qaddcolormap64(QUANT * q, char * colmap, int colors);

/* This will reduce the colors to palwid. It will allocate memory
 * for idxmap and pal, and will free everything that has to do
 * with QUANT *q, including *q itself.
 * idxmap is index map to the palette, so you can remap the
 * colors of your pictures or whatever..
 * *(idxmap+old_color)==new_color;
 */
extern int qreduce(QUANT * q, int ** idxmap, char ** pal, int palwid);

#endif
